diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/block-ack-manager.h ns-3.38/src/wifi/model/block-ack-manager.h
--- ns-3.37/src/wifi/model/block-ack-manager.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/block-ack-manager.h	2023-03-16 20:54:23.852869300 -0700
@@ -22,6 +22,7 @@
 
 #include "block-ack-type.h"
 #include "originator-block-ack-agreement.h"
+#include "recipient-block-ack-agreement.h"
 #include "wifi-mac-header.h"
 #include "wifi-mpdu.h"
 #include "wifi-tx-vector.h"
@@ -40,29 +41,7 @@
 class CtrlBAckResponseHeader;
 class CtrlBAckRequestHeader;
 class WifiMacQueue;
-class WifiMode;
-class Packet;
-
-/**
- * \ingroup wifi
- * \brief BlockAckRequest frame information
- *
- */
-struct Bar
-{
-    Bar();
-    /**
-     * Store a BlockAckRequest along with the corresponding TID or a MU-BAR Trigger Frame.
-     *
-     * \param bar the BAR
-     * \param tid the Traffic ID
-     * \param skipIfNoDataQueued true to hold this BAR if there is no data queued
-     */
-    Bar(Ptr<const WifiMpdu> bar, uint8_t tid, bool skipIfNoDataQueued = false);
-    Ptr<const WifiMpdu> bar; ///< BlockAckRequest or MU-BAR Trigger Frame
-    uint8_t tid;             ///< TID (unused if MU-BAR)
-    bool skipIfNoDataQueued; ///< do not send if there is no data queued (unused if MU-BAR)
-};
+class MacRxMiddle;
 
 /**
  * \brief Manages all block ack agreements for an originator station.
@@ -95,46 +74,45 @@
     BlockAckManager(const BlockAckManager&) = delete;
     BlockAckManager& operator=(const BlockAckManager&) = delete;
 
+    /// optional const reference to OriginatorBlockAckAgreement
+    using OriginatorAgreementOptConstRef =
+        std::optional<std::reference_wrapper<const OriginatorBlockAckAgreement>>;
+    /// optional const reference to RecipientBlockAckAgreement
+    using RecipientAgreementOptConstRef =
+        std::optional<std::reference_wrapper<const RecipientBlockAckAgreement>>;
+
     /**
-     * Provide information about all the Block Ack Managers installed on this device.
-     *
-     * \param bamMap an AC-indexed map of all the Block Ack Managers installed on this device
-     */
-    void SetBlockAckManagerMap(const std::map<AcIndex, Ptr<BlockAckManager>>& bamMap);
-    /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID.
+     * \param recipient MAC address of the recipient
+     * \param tid Traffic ID
      *
-     * \return true  if a block ack agreement exists, false otherwise
+     * \return a const reference to the block ack agreement with the given recipient, if it exists
      *
-     * Checks if a block ack agreement exists with station addressed by
-     * <i>recipient</i> for TID <i>tid</i>.
+     * Check if we are the originator of an existing block ack agreement with the given recipient.
      */
-    bool ExistsAgreement(Mac48Address recipient, uint8_t tid) const;
+    OriginatorAgreementOptConstRef GetAgreementAsOriginator(const Mac48Address& recipient,
+                                                            uint8_t tid) const;
     /**
-     * \param recipient Address of peer station involved in block ack mechanism.
-     * \param tid Traffic ID.
-     * \param state The state for block ack agreement
+     * \param originator MAC address of the originator
+     * \param tid Traffic ID
      *
-     * \return true if a block ack agreement exists, false otherwise
+     * \return a const reference to the block ack agreement with the given originator, if it exists
      *
-     * Checks if a block ack agreement with a state equals to <i>state</i> exists with
-     * station addressed by <i>recipient</i> for TID <i>tid</i>.
+     * Check if we are the recipient of an existing block ack agreement with the given originator.
      */
-    bool ExistsAgreementInState(Mac48Address recipient,
-                                uint8_t tid,
-                                OriginatorBlockAckAgreement::State state) const;
+    RecipientAgreementOptConstRef GetAgreementAsRecipient(const Mac48Address& originator,
+                                                          uint8_t tid) const;
+
     /**
      * \param reqHdr Relative Add block ack request (action frame).
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param htSupported Whether both originator and recipient support HT
      *
-     * Creates a new block ack agreement in pending state. When a ADDBA response
+     * Creates a new originator block ack agreement in pending state. When a ADDBA response
      * with a successful status code is received, the relative agreement becomes established.
      */
-    void CreateAgreement(const MgtAddBaRequestHeader* reqHdr,
-                         Mac48Address recipient,
-                         bool htSupported = true);
+    void CreateOriginatorAgreement(const MgtAddBaRequestHeader& reqHdr,
+                                   const Mac48Address& recipient,
+                                   bool htSupported = true);
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid traffic ID of transmitted packet.
@@ -142,7 +120,7 @@
      * Invoked when a recipient reject a block ack agreement or when a DELBA frame
      * is Received/Transmitted.
      */
-    void DestroyAgreement(Mac48Address recipient, uint8_t tid);
+    void DestroyOriginatorAgreement(const Mac48Address& recipient, uint8_t tid);
     /**
      * \param respHdr Relative Add block ack response (action frame).
      * \param recipient Address of peer station involved in block ack mechanism.
@@ -150,9 +128,40 @@
      *
      * Invoked upon receipt of a ADDBA response frame from <i>recipient</i>.
      */
-    void UpdateAgreement(const MgtAddBaResponseHeader* respHdr,
-                         Mac48Address recipient,
-                         uint16_t startingSeq);
+    void UpdateOriginatorAgreement(const MgtAddBaResponseHeader& respHdr,
+                                   const Mac48Address& recipient,
+                                   uint16_t startingSeq);
+
+    /**
+     * \param respHdr Add block ack response from originator (action
+     *        frame).
+     * \param originator Address of peer station involved in block ack
+     *        mechanism.
+     * \param startingSeq Sequence number of the first MPDU of all
+     *        packets for which block ack was negotiated.
+     * \param htSupported whether HT support is enabled
+     * \param rxMiddle the MAC RX Middle on this station
+     *
+     * This function is typically invoked only by ns3::WifiMac
+     * when the STA (which may be non-AP in ESS, or in an IBSS) has
+     * received an ADDBA Request frame and is transmitting an ADDBA
+     * Response frame. At this point the frame exchange manager must
+     * allocate buffers to collect all correctly received packets belonging
+     * to the category for which block ack was negotiated.
+     */
+    void CreateRecipientAgreement(const MgtAddBaResponseHeader& respHdr,
+                                  const Mac48Address& originator,
+                                  uint16_t startingSeq,
+                                  bool htSupported,
+                                  Ptr<MacRxMiddle> rxMiddle);
+    /**
+     * Destroy a recipient Block Ack agreement.
+     *
+     * \param originator the originator MAC address
+     * \param tid the TID associated with the Block Ack agreement
+     */
+    void DestroyRecipientAgreement(const Mac48Address& originator, uint8_t tid);
+
     /**
      * \param mpdu MPDU to store.
      *
@@ -161,39 +170,27 @@
      */
     void StorePacket(Ptr<WifiMpdu> mpdu);
     /**
-     * Returns the next BlockAckRequest or MU-BAR Trigger Frame to send, if any.
-     * If the given recipient is not the broadcast address and the given TID is less
-     * than 8, then only return a BlockAckRequest, if any, addressed to that recipient
-     * and for the given TID.
-     *
-     * \param remove true if the BAR has to be removed from the queue
-     * \param tid the TID
-     * \param recipient the recipient of the BAR
-     *
-     * \return the next BAR to be sent, if any
-     */
-    Ptr<const WifiMpdu> GetBar(bool remove = true,
-                               uint8_t tid = 8,
-                               Mac48Address recipient = Mac48Address::GetBroadcast());
-    /**
-     * Invoked upon receipt of an Ack frame after the transmission of a QoS data frame
-     * sent under an established block ack agreement. Remove the acknowledged frame
-     * from the outstanding packets and update the starting sequence number of the
+     * Invoked upon receipt of an Ack frame on the given link after the transmission of a
+     * QoS data frame sent under an established block ack agreement. Remove the acknowledged
+     * frame from the outstanding packets and update the starting sequence number of the
      * transmit window, if needed.
      *
+     * \param linkId the ID of the given link
      * \param mpdu The acknowledged MPDU.
      */
-    void NotifyGotAck(Ptr<const WifiMpdu> mpdu);
+    void NotifyGotAck(uint8_t linkId, Ptr<const WifiMpdu> mpdu);
     /**
-     * Invoked upon missed reception of an Ack frame after the transmission of a
-     * QoS data frame sent under an established block ack agreement. Remove the
-     * acknowledged frame from the outstanding packets and insert it in the
+     * Invoked upon missed reception of an Ack frame on the given link after the
+     * transmission of a QoS data frame sent under an established block ack agreement.
+     * Remove the acknowledged frame from the outstanding packets and insert it in the
      * retransmission queue.
      *
+     * \param linkId the ID of the given link
      * \param mpdu The unacknowledged MPDU.
      */
-    void NotifyMissedAck(Ptr<WifiMpdu> mpdu);
+    void NotifyMissedAck(uint8_t linkId, Ptr<WifiMpdu> mpdu);
     /**
+     * \param linkId the ID of the given link
      * \param blockAck The received BlockAck frame.
      * \param recipient Sender of BlockAck frame.
      * \param tids the set of TIDs the acknowledged MPDUs belong to
@@ -202,26 +199,44 @@
      * \return a pair of values indicating the number of successfully received MPDUs
      *         and the number of failed MPDUs
      *
-     * Invoked upon receipt of a BlockAck frame. Typically, this function, is called
-     * by ns3::QosTxop object. Performs a check on which MPDUs, previously sent
+     * Invoked upon receipt of a BlockAck frame on the given link. Typically, this function
+     * is called by ns3::QosTxop object. Performs a check on which MPDUs, previously sent
      * with Ack Policy set to Block Ack, were correctly received by the recipient.
      * An acknowledged MPDU is removed from the buffer, retransmitted otherwise.
      * Note that <i>tids</i> is only used if <i>blockAck</i> is a Multi-STA Block Ack
      * using All-ack context.
      */
-    std::pair<uint16_t, uint16_t> NotifyGotBlockAck(const CtrlBAckResponseHeader& blockAck,
-                                                    Mac48Address recipient,
+    std::pair<uint16_t, uint16_t> NotifyGotBlockAck(uint8_t linkId,
+                                                    const CtrlBAckResponseHeader& blockAck,
+                                                    const Mac48Address& recipient,
                                                     const std::set<uint8_t>& tids,
                                                     size_t index = 0);
     /**
+     * \param linkId the ID of the given link
      * \param recipient Sender of the expected BlockAck frame.
      * \param tid Traffic ID.
      *
-     * Invoked upon missed reception of a block ack frame. Typically, this function, is called
-     * by ns3::QosTxop object. Performs a check on which MPDUs, previously sent
-     * with ack policy set to Block Ack, should be placed in the retransmission queue.
+     * Invoked upon missed reception of a block ack frame on the given link. Typically, this
+     * function is called by ns3::QosTxop object. Performs a check on which MPDUs, previously
+     * sent with ack policy set to Block Ack, should be placed in the retransmission queue.
      */
-    void NotifyMissedBlockAck(Mac48Address recipient, uint8_t tid);
+    void NotifyMissedBlockAck(uint8_t linkId, const Mac48Address& recipient, uint8_t tid);
+    /**
+     * \param originator MAC address of the sender of the Block Ack Request
+     * \param tid Traffic ID
+     * \param startingSeq the starting sequence number in the Block Ack Request
+     *
+     * Perform required actions upon receiving a Block Ack Request frame.
+     */
+    void NotifyGotBlockAckRequest(const Mac48Address& originator,
+                                  uint8_t tid,
+                                  uint16_t startingSeq);
+    /**
+     * \param mpdu the received MPDU
+     *
+     * Perform required actions upon receiving an MPDU.
+     */
+    void NotifyGotMpdu(Ptr<const WifiMpdu> mpdu);
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid Traffic ID.
@@ -231,42 +246,44 @@
      * Returns the number of packets buffered for a specified agreement. This methods doesn't return
      * the number of buffered MPDUs but the number of buffered MSDUs.
      */
-    uint32_t GetNBufferedPackets(Mac48Address recipient, uint8_t tid) const;
+    uint32_t GetNBufferedPackets(const Mac48Address& recipient, uint8_t tid) const;
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid Traffic ID of transmitted packet.
      * \param startingSeq starting sequence field
      *
-     * Puts corresponding agreement in established state and updates number of packets
+     * Puts corresponding originator agreement in established state and updates number of packets
      * and starting sequence field. Invoked typically after a block ack refresh.
      */
-    void NotifyAgreementEstablished(Mac48Address recipient, uint8_t tid, uint16_t startingSeq);
+    void NotifyOriginatorAgreementEstablished(const Mac48Address& recipient,
+                                              uint8_t tid,
+                                              uint16_t startingSeq);
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid Traffic ID of transmitted packet.
      *
-     * Marks an agreement as rejected. This happens if <i>recipient</i> station reject block ack
-     * setup by an ADDBA Response frame with a failure status code. For now we assume that every QoS
-     * station accepts a block ack setup.
+     * Marks an originator agreement as rejected. This happens if <i>recipient</i> station reject
+     * block ack setup by an ADDBA Response frame with a failure status code. For now we assume
+     * that every QoS station accepts a block ack setup.
      */
-    void NotifyAgreementRejected(Mac48Address recipient, uint8_t tid);
+    void NotifyOriginatorAgreementRejected(const Mac48Address& recipient, uint8_t tid);
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid Traffic ID of transmitted packet.
      *
-     * Marks an agreement after not receiving response to ADDBA request. During this state
-     * any packets in queue will be transmitted using normal MPDU. This also unblock
+     * Marks an originator agreement after not receiving response to ADDBA request. During this
+     * state any packets in queue will be transmitted using normal MPDU. This also unblocks
      * recipient address.
      */
-    void NotifyAgreementNoReply(Mac48Address recipient, uint8_t tid);
+    void NotifyOriginatorAgreementNoReply(const Mac48Address& recipient, uint8_t tid);
     /**
      * \param recipient Address of peer station involved in block ack mechanism.
      * \param tid Traffic ID of transmitted packet.
      *
-     * Set BA agreement to a transitory state to reset it after not receiving response to ADDBA
-     * request.
+     * Set Originator BA agreement to a transitory state to reset it after not receiving response
+     * to ADDBA request.
      */
-    void NotifyAgreementReset(Mac48Address recipient, uint8_t tid);
+    void NotifyOriginatorAgreementReset(const Mac48Address& recipient, uint8_t tid);
     /**
      * \param nPackets Minimum number of packets for use of block ack.
      *
@@ -298,20 +315,6 @@
     void SetUnblockDestinationCallback(Callback<void, Mac48Address, uint8_t> callback);
 
     /**
-     * \param recipient the destination address
-     * \param tid the Traffic ID
-     * \param startingSeq the starting sequence number
-     *
-     * \return true if there are packets in the queue that could be sent under block ack,
-     *         false otherwise
-     *
-     * Checks if there are in the queue other packets that could be send under block ack.
-     * If yes adds these packets in current block ack exchange.
-     * However, number of packets exchanged in the current block ack, will not exceed
-     * the value of BufferSize in the corresponding OriginatorBlockAckAgreement object.
-     */
-    bool SwitchToBlockAckIfNeeded(Mac48Address recipient, uint8_t tid, uint16_t startingSeq);
-    /**
      * This function returns true if a block ack agreement is established with the
      * given recipient for the given TID and there is at least an outstanding MPDU
      * for such agreement whose lifetime is not expired.
@@ -321,7 +324,7 @@
      *
      * \returns true if BAR retransmission needed
      */
-    bool NeedBarRetransmission(uint8_t tid, Mac48Address recipient);
+    bool NeedBarRetransmission(uint8_t tid, const Mac48Address& recipient);
     /**
      * This function returns the buffer size negotiated with the recipient.
      *
@@ -330,25 +333,7 @@
      *
      * \returns the buffer size negotiated with the recipient
      */
-    uint16_t GetRecipientBufferSize(Mac48Address recipient, uint8_t tid) const;
-    /**
-     * This function returns the type of Block Acks sent to the recipient.
-     *
-     * \param recipient MAC address of recipient
-     * \param tid Traffic ID
-     *
-     * \returns the type of Block Acks sent to the recipient
-     */
-    BlockAckReqType GetBlockAckReqType(Mac48Address recipient, uint8_t tid) const;
-    /**
-     * This function returns the type of Block Acks sent by the recipient.
-     *
-     * \param recipient MAC address
-     * \param tid Traffic ID
-     *
-     * \returns the type of Block Acks sent by the recipient
-     */
-    BlockAckType GetBlockAckType(Mac48Address recipient, uint8_t tid) const;
+    uint16_t GetRecipientBufferSize(const Mac48Address& recipient, uint8_t tid) const;
     /**
      * This function returns the starting sequence number of the transmit window.
      *
@@ -357,7 +342,7 @@
      *
      * \returns the starting sequence number of the transmit window (WinStartO)
      */
-    uint16_t GetOriginatorStartingSequence(Mac48Address recipient, uint8_t tid) const;
+    uint16_t GetOriginatorStartingSequence(const Mac48Address& recipient, uint8_t tid) const;
 
     /**
      * typedef for a callback to invoke when an MPDU is successfully ack'ed.
@@ -379,7 +364,7 @@
     void SetTxOkCallback(TxOk callback);
     /**
      * \param callback the callback to invoke when a
-     * packet transmission was completed unsuccessfully.
+     * packet transmission was completed unsuccessfuly.
      */
     void SetTxFailedCallback(TxFailed callback);
     /**
@@ -396,7 +381,7 @@
      * \param [in] state The state.
      */
     typedef void (*AgreementStateTracedCallback)(Time now,
-                                                 Mac48Address recipient,
+                                                 const Mac48Address& recipient,
                                                  uint8_t tid,
                                                  OriginatorBlockAckAgreement::State state);
 
@@ -420,18 +405,50 @@
      * Get the BlockAckRequest header for the established BA agreement
      * (<i>recipient</i>,<i>tid</i>).
      */
-    CtrlBAckRequestHeader GetBlockAckReqHeader(Mac48Address recipient, uint8_t tid) const;
+    CtrlBAckRequestHeader GetBlockAckReqHeader(const Mac48Address& recipient, uint8_t tid) const;
 
     /**
      * \param bar the BlockAckRequest to enqueue
-     * \param skipIfNoDataQueued do not send if there is no data queued
      *
-     * Enqueue the given BlockAckRequest into the queue storing the next BAR
+     * Enqueue the given BlockAckRequest into the queue storing the next (MU-)BAR
      * frames to transmit. If a BAR for the same recipient and TID is already present
      * in the queue, it is replaced by the new one. If the given BAR is retransmitted,
      * it is placed at the head of the queue, otherwise at the tail.
      */
-    void ScheduleBar(Ptr<const WifiMpdu> bar, bool skipIfNoDataQueued = false);
+    void ScheduleBar(Ptr<WifiMpdu> bar);
+    /**
+     * \param muBar the MU-BAR Trigger Frame to enqueue
+     *
+     * Enqueue the given MU-BAR Trigger Frame into the queue storing the next (MU-)BAR
+     * frames to transmit. If the given MU-BAR Trigger Frame is retransmitted,
+     * it is placed at the head of the queue, otherwise at the tail.
+     */
+    void ScheduleMuBar(Ptr<WifiMpdu> muBar);
+
+    /// agreement key typedef (MAC address and TID)
+    using AgreementKey = std::pair<Mac48Address, uint8_t>;
+
+    /**
+     * \return the list of BA agreements (identified by the recipient and TID pair) for which a BAR
+     * shall only be sent if there are queued data frames belonging to those agreements
+     */
+    const std::list<AgreementKey>& GetSendBarIfDataQueuedList() const;
+    /**
+     * Add the given (recipient, TID) pair to the list of BA agreements for which a BAR
+     * shall only be sent if there are queued data frames belonging to those agreements
+     *
+     * \param recipient the recipient
+     * \param tid the TID
+     */
+    void AddToSendBarIfDataQueuedList(const Mac48Address& recipient, uint8_t tid);
+    /**
+     * Remove the given (recipient, TID) pair from the list of BA agreements for which a BAR
+     * shall only be sent if there are queued data frames belonging to those agreements
+     *
+     * \param recipient the recipient
+     * \param tid the TID
+     */
+    void RemoveFromSendBarIfDataQueuedList(const Mac48Address& recipient, uint8_t tid);
 
   protected:
     void DoDispose() override;
@@ -442,7 +459,7 @@
      * \param recipient the recipient MAC address
      * \param tid Traffic ID
      */
-    void InactivityTimeout(Mac48Address recipient, uint8_t tid);
+    void InactivityTimeout(const Mac48Address& recipient, uint8_t tid);
 
     /**
      * typedef for a list of WifiMpdu.
@@ -452,27 +469,15 @@
      * typedef for an iterator for PacketQueue.
      */
     typedef std::list<Ptr<WifiMpdu>>::iterator PacketQueueI;
-    /**
-     * typedef for a const iterator for PacketQueue.
-     */
-    typedef std::list<Ptr<WifiMpdu>>::const_iterator PacketQueueCI;
-    /**
-     * typedef for a map between MAC address and block ack agreement.
-     */
-    typedef std::map<std::pair<Mac48Address, uint8_t>,
-                     std::pair<OriginatorBlockAckAgreement, PacketQueue>>
-        Agreements;
-    /**
-     * typedef for an iterator for Agreements.
-     */
-    typedef std::map<std::pair<Mac48Address, uint8_t>,
-                     std::pair<OriginatorBlockAckAgreement, PacketQueue>>::iterator AgreementsI;
-    /**
-     * typedef for a const iterator for Agreements.
-     */
-    typedef std::map<std::pair<Mac48Address, uint8_t>,
-                     std::pair<OriginatorBlockAckAgreement, PacketQueue>>::const_iterator
-        AgreementsCI;
+
+    /// AgreementKey-indexed map of originator block ack agreements
+    using OriginatorAgreements =
+        std::map<AgreementKey, std::pair<OriginatorBlockAckAgreement, PacketQueue>>;
+    /// typedef for an iterator for Agreements
+    using OriginatorAgreementsI = OriginatorAgreements::iterator;
+
+    /// AgreementKey-indexed map of recipient block ack agreements
+    using RecipientAgreements = std::map<AgreementKey, RecipientBlockAckAgreement>;
 
     /**
      * Handle the given in flight MPDU based on its given status. If the status is
@@ -482,30 +487,33 @@
      * queues (independently of the status) if the MPDU is not stored in the EDCA
      * queue, is an old packet or its lifetime expired.
      *
+     * \param linkId the ID of the link on which the MPDU has been transmitted
      * \param mpduIt an iterator pointing to the MPDU in the queue of in flight MPDUs
      * \param status the status of the in flight MPDU
      * \param it iterator pointing to the Block Ack agreement
      * \param now the current time
      * \return an iterator pointing to the next MPDU in the queue of in flight MPDUs
      */
-    PacketQueueI HandleInFlightMpdu(PacketQueueI mpduIt,
+    PacketQueueI HandleInFlightMpdu(uint8_t linkId,
+                                    PacketQueueI mpduIt,
                                     MpduStatus status,
-                                    const AgreementsI& it,
+                                    const OriginatorAgreementsI& it,
                                     const Time& now);
 
     /**
-     * This data structure contains, for each block ack agreement (recipient, TID), a set of packets
-     * for which an ack by block ack is requested.
+     * This data structure contains, for each originator block ack agreement (recipient, TID),
+     * a set of packets for which an ack by block ack is requested.
      * Every packet or fragment indicated as correctly received in BlockAck frame is
      * erased from this data structure. Pushed back in retransmission queue otherwise.
      */
-    Agreements m_agreements;
+    OriginatorAgreements m_originatorAgreements;
+    RecipientAgreements m_recipientAgreements; //!< Recipient Block Ack agreements
 
-    std::list<Bar> m_bars; ///< list of BARs
+    std::list<AgreementKey> m_sendBarIfDataQueued; ///< list of BA agreements for which a BAR shall
+                                                   ///< only be sent if data is queued
 
-    std::map<AcIndex, Ptr<BlockAckManager>> m_bamMap; ///< AC-indexed map of all Block Ack Managers
-    uint8_t m_blockAckThreshold;                      ///< block ack threshold
-    Ptr<WifiMacQueue> m_queue;                        ///< queue
+    uint8_t m_blockAckThreshold; ///< block ack threshold
+    Ptr<WifiMacQueue> m_queue;   ///< queue
     Callback<void, Mac48Address, uint8_t, bool>
         m_blockAckInactivityTimeout;                      ///< BlockAck inactivity timeout callback
     Callback<void, Mac48Address, uint8_t> m_blockPackets; ///< block packets callback
@@ -518,7 +526,7 @@
      * The trace source fired when a state transition occurred.
      */
     TracedCallback<Time, Mac48Address, uint8_t, OriginatorBlockAckAgreement::State>
-        m_agreementState;
+        m_originatorAgreementState;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/block-ack-type.h ns-3.38/src/wifi/model/block-ack-type.h
--- ns-3.37/src/wifi/model/block-ack-type.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/block-ack-type.h	2023-03-16 20:54:23.852869300 -0700
@@ -44,7 +44,8 @@
         MULTI_TID,
         MULTI_STA
     };
-    enum Variant m_variant;           //!< Block Ack variant
+
+    Variant m_variant;                //!< Block Ack variant
     std::vector<uint8_t> m_bitmapLen; //!< Length (bytes) of included bitmaps
 
     /**
@@ -84,7 +85,8 @@
         EXTENDED_COMPRESSED,
         MULTI_TID
     };
-    enum Variant m_variant; //!< Block Ack Request variant
+
+    Variant m_variant;      //!< Block Ack Request variant
     uint8_t m_nSeqControls; //!< Number of included Starting Sequence Control fields.
                             //!< This member is added for future support of Multi-TID BARs
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/channel-access-manager.cc ns-3.38/src/wifi/model/channel-access-manager.cc
--- ns-3.37/src/wifi/model/channel-access-manager.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/channel-access-manager.cc	2023-03-16 20:54:23.852869300 -0700
@@ -627,6 +627,30 @@
     return width;
 }
 
+bool
+ChannelAccessManager::GetPer20MHzBusy(const std::set<uint8_t>& indices) const
+{
+    const auto now = Simulator::Now();
+
+    if (m_phy->GetChannelWidth() < 40)
+    {
+        NS_ASSERT_MSG(indices.size() == 1 && *indices.cbegin() == 0,
+                      "Index 0 only can be specified if the channel width is less than 40 MHz");
+        return m_lastBusyEnd.at(WIFI_CHANLIST_PRIMARY) > now;
+    }
+
+    for (const auto index : indices)
+    {
+        NS_ASSERT(index < m_lastPer20MHzBusyEnd.size());
+        if (m_lastPer20MHzBusyEnd.at(index) > now)
+        {
+            NS_LOG_DEBUG("20 MHz channel with index " << +index << " is busy");
+            return true;
+        }
+    }
+    return false;
+}
+
 void
 ChannelAccessManager::DisableEdcaFor(Ptr<Txop> qosTxop, Time duration)
 {
@@ -706,8 +730,10 @@
     NS_ASSERT(lastBusyEndIt != m_lastBusyEnd.end());
     Time now = Simulator::Now();
     lastBusyEndIt->second = now + duration;
-    // TODO uncomment assert below when PHY passes correct parameters
-    // NS_ASSERT (per20MhzDurations.size () == m_lastPer20MHzBusyEnd.size ());
+    NS_ASSERT_MSG(per20MhzDurations.size() == m_lastPer20MHzBusyEnd.size(),
+                  "Size of received vector (" << per20MhzDurations.size()
+                                              << ") differs from the expected size ("
+                                              << m_lastPer20MHzBusyEnd.size() << ")");
     for (std::size_t chIdx = 0; chIdx < per20MhzDurations.size(); ++chIdx)
     {
         if (per20MhzDurations[chIdx].IsStrictlyPositive())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/channel-access-manager.h ns-3.38/src/wifi/model/channel-access-manager.h
--- ns-3.37/src/wifi/model/channel-access-manager.h	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/model/channel-access-manager.h	2023-03-16 20:54:23.852869300 -0700
@@ -150,6 +150,13 @@
     uint16_t GetLargestIdlePrimaryChannel(Time interval, Time end);
 
     /**
+     * \param indices a set of indices (starting at 0) specifying the 20 MHz channels to test
+     * \return true if per-20 MHz CCA indicates busy for at least one of the
+     *         specified 20 MHz channels, false otherwise
+     */
+    bool GetPer20MHzBusy(const std::set<uint8_t>& indices) const;
+
+    /**
      * \param duration expected duration of reception
      *
      * Notify the Txop that a packet reception started
@@ -163,7 +170,7 @@
     void NotifyRxEndOkNow();
     /**
      * Notify the Txop that a packet reception was just
-     * completed unsuccessfully.
+     * completed unsuccessfuly.
      */
     void NotifyRxEndErrorNow();
     /**
